blob: 54ac6e8644bc5f16c63e027c032d829554158ee1 [file] [log] [blame]
Sean Condonf6af2a52018-08-19 10:43:24 +01001"""
2 Copyright 2018-present Open Networking Foundation
3
4 Licensed under the Apache License, Version 2.0 (the "License");
5 you may not use this file except in compliance with the License.
6 You may obtain a copy of the License at
7
8 http://www.apache.org/licenses/LICENSE-2.0
9
10 Unless required by applicable law or agreed to in writing, software
11 distributed under the License is distributed on an "AS IS" BASIS,
12 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 See the License for the specific language governing permissions and
14 limitations under the License.
15"""
16
17"""
18 Rules to build the ONOS GUI 2
19
Sean Condon0c577f62018-11-18 22:40:05 +000020 The GUI2 Angular 7 elements are built here with Angular CLI 'ng'
Sean Condonf6af2a52018-08-19 10:43:24 +010021 Some work is being done in the Bazel community to integrate Bazel and
Sean Condon0c577f62018-11-18 22:40:05 +000022 Angular 7, (Angular Buildtools Convergence -
Sean Condonf6af2a52018-08-19 10:43:24 +010023 https://docs.google.com/document/d/1OlyiUnoTirUj4gecGxJeZBcjHcFr36RvLsvpBl2mxA8/preview)
24 but it is in the very early stages (Aug'18) and not yet fit
25 for production and at present it works as a replacement for Angular CLI
26 (which is not desirable).
27
28 There are plans to extend Bazel it to work with Angular CLI, and if works
29 well this Bazel file may be rearchiteced in future.
30
31 Bazel and npm are incompatibe in how they deal with files. npm likes to
32 follow links to get back to the original canonical path names, and bazel
33 uses links extensively when populating the sandbox. To get around these
34 problems, the rules that follow use filegroups to specify the files as
35 dependencies and then use a genrule to convert the files into a tar ball.
36 Once the tar ball is unrolled into the sandbox, the links are broken, but
37 the build is still hermetic since those files are referred to as dependencies in the genrule.
38"""
39
40COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + [
41 "@javax_ws_rs_api//jar",
42 "@servlet_api//jar",
43 "@jetty_websocket//jar",
44 "@jetty_util//jar",
45 "@jersey_media_multipart//jar",
46 "@jersey_server//jar",
Ray Milkey427e9752018-11-15 16:34:48 -080047 "@jersey_hk2//jar",
Sean Condonf6af2a52018-08-19 10:43:24 +010048 "//utils/rest:onlab-rest",
49 "//core/store/serializers:onos-core-serializers",
50]
51
52TEST_DEPS = TEST + [
53 "//core/api:onos-api-tests",
54 "//drivers/default:onos-drivers-default",
55]
56
57"""
58 Files that get put at the top level of the tar ball
59"""
60
61filegroup(
62 name = "_root_level_files",
63 srcs =
64 [
65 ":angular.json",
66 ":karma.conf.js",
67 ":package.json",
68 ":package-lock.json",
69 ":protractor.conf.js",
70 ":src/main/tsconfig.json",
71 ":src/main/tslint.json",
72 ":tsconfig.json",
73 ],
74)
75
76filegroup(
77 name = "_e2e_test_files",
78 srcs = [
79 ":e2e/app.e2e-spec.ts",
80 ":e2e/app.po.ts",
81 ":e2e/tsconfig.e2e.json",
82 ],
83)
84
85"""
86 Files that get put into the WEB-INF directory of the tar ball
87"""
88
89filegroup(
90 name = "_web_inf_classes_files",
91 srcs =
92 [
93 ":src/main/webapp/error.html",
94 ":src/main/webapp/login.html",
95 ":src/main/webapp/nav.html",
96 ":src/main/webapp/not-ready.html",
Sean Condon55c30532018-10-29 12:26:57 +000097 ":src/main/webapp/onos.global.css",
Sean Condonf6af2a52018-08-19 10:43:24 +010098 ],
99)
100
101"""
Sean Condonf6af2a52018-08-19 10:43:24 +0100102 Run ng build to create outputs in production mode
103 See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for details of the Angular CLI output
Sean Condon5ca00262018-09-06 17:55:25 +0100104
105 To avoid the overhead of having several "npm install" invocations, we just do
Sean Condon0c577f62018-11-18 22:40:05 +0000106 it once in the //web/gui2-fw-lib which is really the core for the whole Angular 7
Sean Condon5ca00262018-09-06 17:55:25 +0100107 structure in ONOS. This copies files in to node_modules, but because the gui2-fw-lib
108 has not been generated at that time we copy it in separately below with the 'tar' cmd
109 and then 'mv'
Sean Condonf6af2a52018-08-19 10:43:24 +0100110"""
111
112genrule(
113 name = "_onos-gui2-ng-build",
114 srcs = [
115 "@nodejs//:bin/npm",
116 "@nodejs//:bin/node",
117 "@nodejs//:bin/node.js",
118 "@nodejs//:bin/nodejs/bin/node",
119 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100120 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
121 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
122 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condon87b78502018-09-17 20:53:24 +0100123 "//apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build",
Sean Condon5ca00262018-09-06 17:55:25 +0100124 ":_root_level_files",
Sean Condonf6af2a52018-08-19 10:43:24 +0100125 ":_web_app_all",
126 ],
127 outs = [
128 "onos-gui2-ng-build-prod.log",
129 "onos-gui2-ng-build.jar",
130 ],
131 cmd = "ROOT=`pwd` &&" +
132 " export HOME=. &&" +
133 " export XDG_CONFIG_HOME=$(@D)/config &&" +
134 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100135 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
136 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100137 " mkdir -p web/gui2 && cd web/gui2 &&" +
138 " jar xf ../../$(location :_web_app_all) &&" +
139 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100140 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
141 " mv package/ node_modules/gui2-fw-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100142 # Add in modules from external packages
143 " FM_GUI2_LIB_FILES=($(locations //apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build)) &&" + # An array of filenames - sorted by time created
144 " tar xf $$ROOT/$${FM_GUI2_LIB_FILES[0]} &&" +
145 " mv package/ node_modules/fm-gui2-lib/ &&" +
146 # End of add in modules from external packages
Sean Condon5ca00262018-09-06 17:55:25 +0100147 " mkdir -p src/main/webapp/app/fw &&" +
148 " (cd src/main/webapp/app/fw &&" +
149 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100150 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700151 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100152 " node -v > ../../$(location onos-gui2-ng-build-prod.log) &&" +
153 " npm -v >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
Sean Condon0c577f62018-11-18 22:40:05 +0000154 " ng version >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
155 " ng build --extract-css --prod --preserve-symlinks" +
Sean Condon87b78502018-09-17 20:53:24 +0100156 " --base-href /onos/ui2/ --deploy-url /onos/ui2/ >> $$ROOT/$(location onos-gui2-ng-build-prod.log) 2>&1 ||" +
157 " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" +
158 " else " +
159 " echo 'Error running \'ng build\' on \'//web/gui2:_onos-gui2-ng-build\'. \\\n" +
160 " See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for more details' >&2;" +
161 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
162 " exit 1;" +
163 " fi;" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100164 " cd src/main/webapp/dist && jar Mcf $$ROOT/$(location onos-gui2-ng-build.jar) .",
Sean Condon0c577f62018-11-18 22:40:05 +0000165 message = "Angular CLI 7 build",
Sean Condonf6af2a52018-08-19 10:43:24 +0100166)
167
168"""
169 Run 'ng test' to run Angular test and 'ng lint' for checkstyle
170 See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log or
171 bazel-genfiles/web/gui2/onos-gui2-ng-test.log for details of the Angular CLI output
172"""
173
174genrule(
175 name = "_onos-gui2-ng-test-genrule",
176 srcs = [
177 "@nodejs//:bin/npm",
178 "@nodejs//:bin/node",
179 "@nodejs//:bin/node.js",
180 "@nodejs//:bin/nodejs/bin/node",
181 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100182 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
183 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
184 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condonf6af2a52018-08-19 10:43:24 +0100185 ":_web_app_all",
186 ":_web_app_tests",
187 ":_angular_all",
188 ],
189 outs = [
190 "onos-gui2-ng-ver.log",
191 "onos-gui2-ng-lint.log",
192 "onos-gui2-ng-test.log",
193 ],
194 cmd = " ROOT=`pwd` &&" +
195 " export HOME=. &&" +
196 " export XDG_CONFIG_HOME=$(@D)/config &&" +
197 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100198 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
199 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100200 " mkdir -p web/gui2 &&" +
201 " cd web/gui2 &&" +
202 " jar xf ../../$(location :_angular_all) &&" +
203 " jar xf ../../$(location :_web_app_all) &&" +
204 " jar xf ../../$(location :_web_app_tests) &&" +
205 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100206 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
207 " mv package/ node_modules/gui2-fw-lib/ &&" +
208 " mkdir -p src/main/webapp/app/fw &&" +
209 " (cd src/main/webapp/app/fw &&" +
210 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100211 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700212 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100213 " node -v > ../../$(location onos-gui2-ng-ver.log) &&" +
214 " npm -v >> ../../$(location onos-gui2-ng-ver.log) &&" +
Sean Condon50855cf2018-12-23 15:37:42 +0000215 " ng version >> ../../$(location onos-gui2-ng-ver.log);" +
216 " ng lint > ../../$(location onos-gui2-ng-lint.log) 2>&1 ||" +
217 " if [ $$? -eq 0 ]; then echo 'Successfully ran lint';" +
218 " else " +
219 " echo 'Error running \'ng lint\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
220 " See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log for more details' >&2;" +
221 " exit 1;" +
222 " fi;" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100223 " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome
224 " export CHROME_BIN=/usr/bin/chromium-browser; " +
225 " elif [ -f /opt/google/chrome/chrome ]; then " +
226 " export CHROME_BIN=/opt/google/chrome/chrome; " +
227 " else " +
228 " MSG='Warning: Step onos-gui2-ng-test skipped because \\n" +
229 " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" +
230 " Install Google Chrome or Chromium Browser to allow this step to run.';" +
231 " echo -e $$MSG >&2;" +
232 " echo -e $$MSG > ../../$(location onos-gui2-ng-test.log);" +
233 " exit 0;" +
234 " fi;" +
235 " ng test --preserve-symlinks --code-coverage --browsers=ChromeHeadless" +
236 " --watch=false > ../../$(location onos-gui2-ng-test.log) 2>&1 ||" +
237 " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" +
238 " else " +
239 " echo 'Error running \'ng test\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
240 " See bazel-genfiles/web/gui2/onos-gui2-ng-test.log for more details' >&2;" +
241 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
242 " exit 1;" +
243 " fi;",
Sean Condon0c577f62018-11-18 22:40:05 +0000244 message = "Angular CLI 7 lint and test",
Sean Condonf6af2a52018-08-19 10:43:24 +0100245)
246
247"""
248 Make a jar file of all the webapp files. Useful for breaking symblic links in the sandbox
249"""
250
251genrule(
252 name = "_web_app_all",
253 srcs = glob(
254 [
255 "src/main/webapp/**",
256 ],
257 exclude = [
258 "src/main/webapp/**/*.spec.ts", # Don't track tests here
259 "src/main/webapp/tests/**",
260 "src/main/webapp/node_modules/**",
261 "src/main/webapp/dist/**",
262 "src/main/webapp/doc/**",
Sean Condon87b78502018-09-17 20:53:24 +0100263 "src/main/webapp/app/fw/**",
Sean Condonf6af2a52018-08-19 10:43:24 +0100264 ],
265 ),
266 outs = ["web_app_all.jar"],
267 cmd = "cd web/gui2 &&" +
268 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
269 " jar Mcf ../../$@ src/main/webapp",
270)
271
272"""
273 Make a jar file of all the webapp test (*.spec.ts) files.
274"""
275
276genrule(
277 name = "_web_app_tests",
278 srcs = glob(
279 [
280 "src/main/webapp/**/*.spec.ts",
281 ],
282 exclude = [
283 "src/main/webapp/tests/**",
284 "src/main/webapp/node_modules/**",
285 "src/main/webapp/dist/**",
286 "src/main/webapp/doc/**",
287 ],
288 ),
289 outs = ["web_app_tests.jar"],
290 cmd = "cd web/gui2 &&" +
291 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
292 " jar Mcf ../../$@ src/main/webapp",
293)
294
295"""
296 Make a jar file of all the supporting files. Useful for breaking symblic links in the sandbox
297"""
298
299genrule(
300 name = "_angular_all",
301 srcs = [
302 ":_e2e_test_files",
303 ":_root_level_files",
304 ],
305 outs = ["angular_all.jar"],
306 cmd = " cd web/gui2 && jar Mcf ../../$@ .",
307)
308
309"""
310 Builds the java jar for the java code provided by the GUI2
311"""
312
313osgi_jar_with_tests(
314 name = "_onos-gui2-base-jar",
Sean Condon87b78502018-09-17 20:53:24 +0100315 srcs =
316 glob([
317 "src/main/java/**",
318 ]) + [
319 "//web/gui:onos-gui-java-for-gui2",
320 ],
Sean Condon3c8e5582018-08-28 23:22:43 +0100321 suppress_checkstyle = True,
Sean Condonf6af2a52018-08-19 10:43:24 +0100322 test_deps = TEST_DEPS,
323 web_context = "/onos/ui2",
324 deps = COMPILE_DEPS,
325)
326
327"""
328 Builds the tar ball for the ONOS GUI2
329"""
330
331genrule(
332 name = "onos-gui2",
333 srcs = [
334 ":_onos-gui2-ng-build",
335 ":_onos-gui2-base-jar",
336 ":_web_inf_classes_files",
Sean Condon3c8e5582018-08-28 23:22:43 +0100337 "src/main/webapp/WEB-INF/web.xml",
Sean Condonf6af2a52018-08-19 10:43:24 +0100338 ],
339 outs = ["onos-gui2.jar"],
340 cmd = " ROOT=`pwd` &&" +
341 " mkdir -p web/gui2/WEB-INF/classes &&" +
342 " cd web/gui2 &&" +
343 " BUILD_FILES=($(locations :_onos-gui2-ng-build)) &&" + # An array of filenames - sorted by time created
344 " for i in $(locations :_web_inf_classes_files); do cp $$ROOT/$$i ./WEB-INF/classes/; done &&" +
345 " (cd WEB-INF/classes && jar xf $$ROOT/$${BUILD_FILES[1]}) &&" +
346 " jar xf $$ROOT/$(location :_onos-gui2-base-jar) &&" +
347 " find . -type f -exec touch -t 201808280000 {} \; &&" +
Sean Condon3c8e5582018-08-28 23:22:43 +0100348 " jar cmf META-INF/MANIFEST.MF $$ROOT/$@ WEB-INF/web.xml WEB-INF/classes",
Sean Condonf6af2a52018-08-19 10:43:24 +0100349 output_to_bindir = 1,
350 visibility = ["//visibility:public"],
351)
352
353"""
354 Wrap the genrule for testing in a test
355"""
356
357sh_test(
358 name = "onos-gui2-ng-tests",
359 size = "small",
360 srcs = [
361 ":ng-test.sh",
362 ],
363 data = [
364 ":_onos-gui2-ng-test-genrule",
365 ],
366 deps = [
367 "@bazel_tools//tools/bash/runfiles",
368 ],
369)